## PhoshNotifyDBusNotificationsSkeleton

PhoshNotifyDBusNotificationsSkeleton

## Functions

GDBusInterfaceInfo * | phosh_notify_dbus_notifications_interface_info ()
guint | phosh_notify_dbus_notifications_override_properties ()
void | phosh_notify_dbus_notifications_complete_get_capabilities ()
void | phosh_notify_dbus_notifications_complete_notify ()
void | phosh_notify_dbus_notifications_complete_close_notification ()
void | phosh_notify_dbus_notifications_complete_get_server_information ()
void | phosh_notify_dbus_notifications_emit_notification_closed ()
void | phosh_notify_dbus_notifications_emit_action_invoked ()
void | phosh_notify_dbus_notifications_call_get_capabilities ()
gboolean | phosh_notify_dbus_notifications_call_get_capabilities_finish ()
gboolean | phosh_notify_dbus_notifications_call_get_capabilities_sync ()
void | phosh_notify_dbus_notifications_call_notify ()
gboolean | phosh_notify_dbus_notifications_call_notify_finish ()
gboolean | phosh_notify_dbus_notifications_call_notify_sync ()
void | phosh_notify_dbus_notifications_call_close_notification ()
gboolean | phosh_notify_dbus_notifications_call_close_notification_finish ()
gboolean | phosh_notify_dbus_notifications_call_close_notification_sync ()
void | phosh_notify_dbus_notifications_call_get_server_information ()
gboolean | phosh_notify_dbus_notifications_call_get_server_information_finish ()
gboolean | phosh_notify_dbus_notifications_call_get_server_information_sync ()
void | phosh_notify_dbus_notifications_proxy_new ()
PhoshNotifyDBusNotifications * | phosh_notify_dbus_notifications_proxy_new_finish ()
PhoshNotifyDBusNotifications * | phosh_notify_dbus_notifications_proxy_new_sync ()
void | phosh_notify_dbus_notifications_proxy_new_for_bus ()
PhoshNotifyDBusNotifications * | phosh_notify_dbus_notifications_proxy_new_for_bus_finish ()
PhoshNotifyDBusNotifications * | phosh_notify_dbus_notifications_proxy_new_for_bus_sync ()
PhoshNotifyDBusNotifications * | phosh_notify_dbus_notifications_skeleton_new ()

## Signals

void | action-invoked | Run Last
gboolean | handle-close-notification | Run Last
gboolean | handle-get-capabilities | Run Last
gboolean | handle-get-server-information | Run Last
gboolean | handle-notify | Run Last
void | notification-closed | Run Last

## Types and Values

struct | PhoshNotifyDBusNotificationsIface
struct | PhoshNotifyDBusNotificationsProxy
struct | PhoshNotifyDBusNotificationsProxyClass
struct | PhoshNotifyDBusNotificationsSkeleton
struct | PhoshNotifyDBusNotificationsSkeletonClass
| PhoshNotifyDBusNotifications
| PhoshNotifyDBusNotificationsProxyPrivate
| PhoshNotifyDBusNotificationsSkeletonPrivate

## Object Hierarchy

        GInterface
        ╰── PhoshNotifyDBusNotifications
        GObject
        ├── GDBusInterfaceSkeleton
        │   ╰── PhoshNotifyDBusNotificationsSkeleton
        │       ╰── PhoshNotifyManager
        ╰── GDBusProxy
            ╰── PhoshNotifyDBusNotificationsProxy

## Prerequisites

PhoshNotifyDBusNotifications requires GObject.

## Implemented Interfaces

PhoshNotifyDBusNotificationsProxy implements GDBusInterface, GInitable, GAsyncInitable and PhoshNotifyDBusNotifications.

PhoshNotifyDBusNotificationsSkeleton implements GDBusInterface and PhoshNotifyDBusNotifications.

## Known Implementations

PhoshNotifyDBusNotifications is implemented by PhoshNotifyDBusNotificationsProxy, PhoshNotifyDBusNotificationsSkeleton and PhoshNotifyManager.

## Description

## Functions

### phosh_notify_dbus_notifications_interface_info ()

    GDBusInterfaceInfo *
    phosh_notify_dbus_notifications_interface_info
                                   (void);

Gets a machine-readable description of the org.freedesktop.Notifications D-Bus interface.

#### Returns

A GDBusInterfaceInfo. Do not free.

[transfer none]

### phosh_notify_dbus_notifications_override_properties ()

    guint
    phosh_notify_dbus_notifications_override_properties
                                   (GObjectClass *klass,
                                    guint property_id_begin);

Overrides all GObject properties in the PhoshNotifyDBusNotifications interface for a concrete class. The properties are overridden in the order they are defined.

#### Parameters

klass | The class structure for a GObject derived class. |
property_id_begin | The property id to assign to the first overridden property. |

#### Returns

The last property id.

### phosh_notify_dbus_notifications_complete_get_capabilities ()

    void
    phosh_notify_dbus_notifications_complete_get_capabilities
                                   (PhoshNotifyDBusNotifications *object,
                                    GDBusMethodInvocation *invocation,
                                    const gchar *const *capabilities);

Helper function used in service implementations to finish handling invocations of the `GetCapabilities()` D-Bus method. If you instead want to finish handling an invocation by returning an error, use `g_dbus_method_invocation_return_error()` or similar.

This method will free `invocation` , you cannot use it afterwards.

#### Parameters

object | A PhoshNotifyDBusNotifications. |
invocation | A GDBusMethodInvocation. | [transfer full]
capabilities | Parameter to return. |

### phosh_notify_dbus_notifications_complete_notify ()

    void
    phosh_notify_dbus_notifications_complete_notify
                                   (PhoshNotifyDBusNotifications *object,
                                    GDBusMethodInvocation *invocation,
                                    guint id);

Helper function used in service implementations to finish handling invocations of the `Notify()` D-Bus method. If you instead want to finish handling an invocation by returning an error, use `g_dbus_method_invocation_return_error()` or similar.

This method will free `invocation` , you cannot use it afterwards.

#### Parameters

object | A PhoshNotifyDBusNotifications. |
invocation | A GDBusMethodInvocation. | [transfer full]
id | Parameter to return. |

### phosh_notify_dbus_notifications_complete_close_notification ()

    void
    phosh_notify_dbus_notifications_complete_close_notification
                                   (PhoshNotifyDBusNotifications *object,
                                    GDBusMethodInvocation *invocation);

Helper function used in service implementations to finish handling invocations of the `CloseNotification()` D-Bus method. If you instead want to finish handling an invocation by returning an error, use `g_dbus_method_invocation_return_error()` or similar.

This method will free `invocation` , you cannot use it afterwards.

#### Parameters

object | A PhoshNotifyDBusNotifications. |
invocation | A GDBusMethodInvocation. | [transfer full]

### phosh_notify_dbus_notifications_complete_get_server_information ()

    void
    phosh_notify_dbus_notifications_complete_get_server_information
                                   (PhoshNotifyDBusNotifications *object,
                                    GDBusMethodInvocation *invocation,
                                    const gchar *name,
                                    const gchar *vendor,
                                    const gchar *version,
                                    const gchar *spec_version);

Helper function used in service implementations to finish handling invocations of the `GetServerInformation()` D-Bus method. If you instead want to finish handling an invocation by returning an error, use `g_dbus_method_invocation_return_error()` or similar.

This method will free `invocation` , you cannot use it afterwards.

#### Parameters

object | A PhoshNotifyDBusNotifications. |
invocation | A GDBusMethodInvocation. | [transfer full]
name | Parameter to return. |
vendor | Parameter to return. |
version | Parameter to return. |
spec_version | Parameter to return. |

### phosh_notify_dbus_notifications_emit_notification_closed ()

    void
    phosh_notify_dbus_notifications_emit_notification_closed
                                   (PhoshNotifyDBusNotifications *object,
                                    guint arg_id,
                                    guint arg_reason);

Emits the "NotificationClosed" D-Bus signal.

#### Parameters

object | A PhoshNotifyDBusNotifications. |
arg_id | Argument to pass with the signal. |
arg_reason | Argument to pass with the signal. |

### phosh_notify_dbus_notifications_emit_action_invoked ()

    void
    phosh_notify_dbus_notifications_emit_action_invoked
                                   (PhoshNotifyDBusNotifications *object,
                                    guint arg_id,
                                    const gchar *arg_action_key);

Emits the "ActionInvoked" D-Bus signal.

#### Parameters

object | A PhoshNotifyDBusNotifications. |
arg_id | Argument to pass with the signal. |
arg_action_key | Argument to pass with the signal. |

### phosh_notify_dbus_notifications_call_get_capabilities ()

    void
    phosh_notify_dbus_notifications_call_get_capabilities
                                   (PhoshNotifyDBusNotifications *proxy,
                                    GCancellable *cancellable,
                                    GAsyncReadyCallback callback,
                                    gpointer user_data);

Asynchronously invokes the `GetCapabilities()` D-Bus method on `proxy` . When the operation is finished, `callback` will be invoked in the thread-default main loop of the thread you are calling this method from (see `g_main_context_push_thread_default()`). You can then call `phosh_notify_dbus_notifications_call_get_capabilities_finish()` to get the result of the operation.

See `phosh_notify_dbus_notifications_call_get_capabilities_sync()` for the synchronous, blocking version of this method.

#### Parameters

proxy | A PhoshNotifyDBusNotificationsProxy. |
cancellable | A GCancellable or `NULL`. | [nullable]
callback | A GAsyncReadyCallback to call when the request is satisfied or `NULL`. |
user_data | User data to pass to `callback` . |

### phosh_notify_dbus_notifications_call_get_capabilities_finish ()

    gboolean
    phosh_notify_dbus_notifications_call_get_capabilities_finish
                                   (PhoshNotifyDBusNotifications *proxy,
                                    gchar ***out_capabilities,
                                    GAsyncResult *res,
                                    GError **error);

Finishes an operation started with `phosh_notify_dbus_notifications_call_get_capabilities()`.

#### Parameters

proxy | A PhoshNotifyDBusNotificationsProxy. |
out_capabilities | Return location for return parameter or `NULL` to ignore. | [out][optional][array zero-terminated=1]
res | The GAsyncResult obtained from the GAsyncReadyCallback passed to `phosh_notify_dbus_notifications_call_get_capabilities()`. |
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeeded, `FALSE` if `error` is set.

[skip]

### phosh_notify_dbus_notifications_call_get_capabilities_sync ()

    gboolean
    phosh_notify_dbus_notifications_call_get_capabilities_sync
                                   (PhoshNotifyDBusNotifications *proxy,
                                    gchar ***out_capabilities,
                                    GCancellable *cancellable,
                                    GError **error);

Synchronously invokes the `GetCapabilities()` D-Bus method on `proxy` . The calling thread is blocked until a reply is received.

See `phosh_notify_dbus_notifications_call_get_capabilities()` for the asynchronous version of this method.

#### Parameters

proxy | A PhoshNotifyDBusNotificationsProxy. |
out_capabilities | Return location for return parameter or `NULL` to ignore. | [out][optional][array zero-terminated=1]
cancellable | A GCancellable or `NULL`. | [nullable]
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeeded, `FALSE` if `error` is set.

[skip]

### phosh_notify_dbus_notifications_call_notify ()

    void
    phosh_notify_dbus_notifications_call_notify
                                   (PhoshNotifyDBusNotifications *proxy,
                                    const gchar *arg_app_name,
                                    guint arg_replaces_id,
                                    const gchar *arg_app_icon,
                                    const gchar *arg_summary,
                                    const gchar *arg_body,
                                    const gchar *const *arg_actions,
                                    GVariant *arg_hints,
                                    gint arg_expire_timeout,
                                    GCancellable *cancellable,
                                    GAsyncReadyCallback callback,
                                    gpointer user_data);

Asynchronously invokes the `Notify()` D-Bus method on `proxy` . When the operation is finished, `callback` will be invoked in the thread-default main loop of the thread you are calling this method from (see `g_main_context_push_thread_default()`). You can then call `phosh_notify_dbus_notifications_call_notify_finish()` to get the result of the operation.

See `phosh_notify_dbus_notifications_call_notify_sync()` for the synchronous, blocking version of this method.

#### Parameters

proxy | A PhoshNotifyDBusNotificationsProxy. |
arg_app_name | Argument to pass with the method invocation. |
arg_replaces_id | Argument to pass with the method invocation. |
arg_app_icon | Argument to pass with the method invocation. |
arg_summary | Argument to pass with the method invocation. |
arg_body | Argument to pass with the method invocation. |
arg_actions | Argument to pass with the method invocation. |
arg_hints | Argument to pass with the method invocation. |
arg_expire_timeout | Argument to pass with the method invocation. |
cancellable | A GCancellable or `NULL`. | [nullable]
callback | A GAsyncReadyCallback to call when the request is satisfied or `NULL`. |
user_data | User data to pass to `callback` . |

### phosh_notify_dbus_notifications_call_notify_finish ()

    gboolean
    phosh_notify_dbus_notifications_call_notify_finish
                                   (PhoshNotifyDBusNotifications *proxy,
                                    guint *out_id,
                                    GAsyncResult *res,
                                    GError **error);

Finishes an operation started with `phosh_notify_dbus_notifications_call_notify()`.

#### Parameters

proxy | A PhoshNotifyDBusNotificationsProxy. |
out_id | Return location for return parameter or `NULL` to ignore. | [out][optional]
res | The GAsyncResult obtained from the GAsyncReadyCallback passed to `phosh_notify_dbus_notifications_call_notify()`. |
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeeded, `FALSE` if `error` is set.

[skip]

### phosh_notify_dbus_notifications_call_notify_sync ()

    gboolean
    phosh_notify_dbus_notifications_call_notify_sync
                                   (PhoshNotifyDBusNotifications *proxy,
                                    const gchar *arg_app_name,
                                    guint arg_replaces_id,
                                    const gchar *arg_app_icon,
                                    const gchar *arg_summary,
                                    const gchar *arg_body,
                                    const gchar *const *arg_actions,
                                    GVariant *arg_hints,
                                    gint arg_expire_timeout,
                                    guint *out_id,
                                    GCancellable *cancellable,
                                    GError **error);

Synchronously invokes the `Notify()` D-Bus method on `proxy` . The calling thread is blocked until a reply is received.

See `phosh_notify_dbus_notifications_call_notify()` for the asynchronous version of this method.

#### Parameters

proxy | A PhoshNotifyDBusNotificationsProxy. |
arg_app_name | Argument to pass with the method invocation. |
arg_replaces_id | Argument to pass with the method invocation. |
arg_app_icon | Argument to pass with the method invocation. |
arg_summary | Argument to pass with the method invocation. |
arg_body | Argument to pass with the method invocation. |
arg_actions | Argument to pass with the method invocation. |
arg_hints | Argument to pass with the method invocation. |
arg_expire_timeout | Argument to pass with the method invocation. |
out_id | Return location for return parameter or `NULL` to ignore. | [out][optional]
cancellable | A GCancellable or `NULL`. | [nullable]
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeeded, `FALSE` if `error` is set.

[skip]

### phosh_notify_dbus_notifications_call_close_notification ()

    void
    phosh_notify_dbus_notifications_call_close_notification
                                   (PhoshNotifyDBusNotifications *proxy,
                                    guint arg_id,
                                    GCancellable *cancellable,
                                    GAsyncReadyCallback callback,
                                    gpointer user_data);

Asynchronously invokes the `CloseNotification()` D-Bus method on `proxy` . When the operation is finished, `callback` will be invoked in the thread-default main loop of the thread you are calling this method from (see `g_main_context_push_thread_default()`). You can then call `phosh_notify_dbus_notifications_call_close_notification_finish()` to get the result of the operation.

See `phosh_notify_dbus_notifications_call_close_notification_sync()` for the synchronous, blocking version of this method.

#### Parameters

proxy | A PhoshNotifyDBusNotificationsProxy. |
arg_id | Argument to pass with the method invocation. |
cancellable | A GCancellable or `NULL`. | [nullable]
callback | A GAsyncReadyCallback to call when the request is satisfied or `NULL`. |
user_data | User data to pass to `callback` . |

### phosh_notify_dbus_notifications_call_close_notification_finish ()

    gboolean
    phosh_notify_dbus_notifications_call_close_notification_finish
                                   (PhoshNotifyDBusNotifications *proxy,
                                    GAsyncResult *res,
                                    GError **error);

Finishes an operation started with `phosh_notify_dbus_notifications_call_close_notification()`.

#### Parameters

proxy | A PhoshNotifyDBusNotificationsProxy. |
res | The GAsyncResult obtained from the GAsyncReadyCallback passed to `phosh_notify_dbus_notifications_call_close_notification()`. |
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeeded, `FALSE` if `error` is set.

[skip]

### phosh_notify_dbus_notifications_call_close_notification_sync ()

    gboolean
    phosh_notify_dbus_notifications_call_close_notification_sync
                                   (PhoshNotifyDBusNotifications *proxy,
                                    guint arg_id,
                                    GCancellable *cancellable,
                                    GError **error);

Synchronously invokes the `CloseNotification()` D-Bus method on `proxy` . The calling thread is blocked until a reply is received.

See `phosh_notify_dbus_notifications_call_close_notification()` for the asynchronous version of this method.

#### Parameters

proxy | A PhoshNotifyDBusNotificationsProxy. |
arg_id | Argument to pass with the method invocation. |
cancellable | A GCancellable or `NULL`. | [nullable]
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeeded, `FALSE` if `error` is set.

[skip]

### phosh_notify_dbus_notifications_call_get_server_information ()

    void
    phosh_notify_dbus_notifications_call_get_server_information
                                   (PhoshNotifyDBusNotifications *proxy,
                                    GCancellable *cancellable,
                                    GAsyncReadyCallback callback,
                                    gpointer user_data);

Asynchronously invokes the `GetServerInformation()` D-Bus method on `proxy` . When the operation is finished, `callback` will be invoked in the thread-default main loop of the thread you are calling this method from (see `g_main_context_push_thread_default()`). You can then call `phosh_notify_dbus_notifications_call_get_server_information_finish()` to get the result of the operation.

See `phosh_notify_dbus_notifications_call_get_server_information_sync()` for the synchronous, blocking version of this method.

#### Parameters

proxy | A PhoshNotifyDBusNotificationsProxy. |
cancellable | A GCancellable or `NULL`. | [nullable]
callback | A GAsyncReadyCallback to call when the request is satisfied or `NULL`. |
user_data | User data to pass to `callback` . |

### phosh_notify_dbus_notifications_call_get_server_information_finish ()

    gboolean
    phosh_notify_dbus_notifications_call_get_server_information_finish
                                   (PhoshNotifyDBusNotifications *proxy,
                                    gchar **out_name,
                                    gchar **out_vendor,
                                    gchar **out_version,
                                    gchar **out_spec_version,
                                    GAsyncResult *res,
                                    GError **error);

Finishes an operation started with `phosh_notify_dbus_notifications_call_get_server_information()`.

#### Parameters

proxy | A PhoshNotifyDBusNotificationsProxy. |
out_name | Return location for return parameter or `NULL` to ignore. | [out][optional]
out_vendor | Return location for return parameter or `NULL` to ignore. | [out][optional]
out_version | Return location for return parameter or `NULL` to ignore. | [out][optional]
out_spec_version | Return location for return parameter or `NULL` to ignore. | [out][optional]
res | The GAsyncResult obtained from the GAsyncReadyCallback passed to `phosh_notify_dbus_notifications_call_get_server_information()`. |
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeeded, `FALSE` if `error` is set.

[skip]

### phosh_notify_dbus_notifications_call_get_server_information_sync ()

    gboolean
    phosh_notify_dbus_notifications_call_get_server_information_sync
                                   (PhoshNotifyDBusNotifications *proxy,
                                    gchar **out_name,
                                    gchar **out_vendor,
                                    gchar **out_version,
                                    gchar **out_spec_version,
                                    GCancellable *cancellable,
                                    GError **error);

Synchronously invokes the `GetServerInformation()` D-Bus method on `proxy` . The calling thread is blocked until a reply is received.

See `phosh_notify_dbus_notifications_call_get_server_information()` for the asynchronous version of this method.

#### Parameters

proxy | A PhoshNotifyDBusNotificationsProxy. |
out_name | Return location for return parameter or `NULL` to ignore. | [out][optional]
out_vendor | Return location for return parameter or `NULL` to ignore. | [out][optional]
out_version | Return location for return parameter or `NULL` to ignore. | [out][optional]
out_spec_version | Return location for return parameter or `NULL` to ignore. | [out][optional]
cancellable | A GCancellable or `NULL`. | [nullable]
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeeded, `FALSE` if `error` is set.

[skip]

### phosh_notify_dbus_notifications_proxy_new ()

    void
    phosh_notify_dbus_notifications_proxy_new
                                   (GDBusConnection *connection,
                                    GDBusProxyFlags flags,
                                    const gchar *name,
                                    const gchar *object_path,
                                    GCancellable *cancellable,
                                    GAsyncReadyCallback callback,
                                    gpointer user_data);

Asynchronously creates a proxy for the D-Bus interface org.freedesktop.Notifications. See `g_dbus_proxy_new()` for more details.

When the operation is finished, `callback` will be invoked in the thread-default main loop of the thread you are calling this method from (see `g_main_context_push_thread_default()`). You can then call `phosh_notify_dbus_notifications_proxy_new_finish()` to get the result of the operation.

See `phosh_notify_dbus_notifications_proxy_new_sync()` for the synchronous, blocking version of this constructor.

#### Parameters

connection | A GDBusConnection. |
flags | Flags from the GDBusProxyFlags enumeration. |
name | A bus name (well-known or unique) or `NULL` if `connection` is not a message bus connection. | [nullable]
object_path | An object path. |
cancellable | A GCancellable or `NULL`. | [nullable]
callback | A GAsyncReadyCallback to call when the request is satisfied. |
user_data | User data to pass to `callback` . |

### phosh_notify_dbus_notifications_proxy_new_finish ()

    PhoshNotifyDBusNotifications *
    phosh_notify_dbus_notifications_proxy_new_finish
                                   (GAsyncResult *res,
                                    GError **error);

Finishes an operation started with `phosh_notify_dbus_notifications_proxy_new()`.

#### Parameters

res | The GAsyncResult obtained from the GAsyncReadyCallback passed to `phosh_notify_dbus_notifications_proxy_new()`. |
error | Return location for error or `NULL` |

#### Returns

The constructed proxy object or `NULL` if `error` is set.

[transfer full][type PhoshNotifyDBusNotificationsProxy]

### phosh_notify_dbus_notifications_proxy_new_sync ()

    PhoshNotifyDBusNotifications *
    phosh_notify_dbus_notifications_proxy_new_sync
                                   (GDBusConnection *connection,
                                    GDBusProxyFlags flags,
                                    const gchar *name,
                                    const gchar *object_path,
                                    GCancellable *cancellable,
                                    GError **error);

Synchronously creates a proxy for the D-Bus interface org.freedesktop.Notifications. See `g_dbus_proxy_new_sync()` for more details.

The calling thread is blocked until a reply is received.

See `phosh_notify_dbus_notifications_proxy_new()` for the asynchronous version of this constructor.

#### Parameters

connection | A GDBusConnection. |
flags | Flags from the GDBusProxyFlags enumeration. |
name | A bus name (well-known or unique) or `NULL` if `connection` is not a message bus connection. | [nullable]
object_path | An object path. |
cancellable | A GCancellable or `NULL`. | [nullable]
error | Return location for error or `NULL` |

#### Returns

The constructed proxy object or `NULL` if `error` is set.

[transfer full][type PhoshNotifyDBusNotificationsProxy]

### phosh_notify_dbus_notifications_proxy_new_for_bus ()

    void
    phosh_notify_dbus_notifications_proxy_new_for_bus
                                   (GBusType bus_type,
                                    GDBusProxyFlags flags,
                                    const gchar *name,
                                    const gchar *object_path,
                                    GCancellable *cancellable,
                                    GAsyncReadyCallback callback,
                                    gpointer user_data);

Like `phosh_notify_dbus_notifications_proxy_new()` but takes a GBusType instead of a GDBusConnection.

When the operation is finished, `callback` will be invoked in the thread-default main loop of the thread you are calling this method from (see `g_main_context_push_thread_default()`). You can then call `phosh_notify_dbus_notifications_proxy_new_for_bus_finish()` to get the result of the operation.

See `phosh_notify_dbus_notifications_proxy_new_for_bus_sync()` for the synchronous, blocking version of this constructor.

#### Parameters

bus_type | A GBusType. |
flags | Flags from the GDBusProxyFlags enumeration. |
name | A bus name (well-known or unique). |
object_path | An object path. |
cancellable | A GCancellable or `NULL`. | [nullable]
callback | A GAsyncReadyCallback to call when the request is satisfied. |
user_data | User data to pass to `callback` . |

### phosh_notify_dbus_notifications_proxy_new_for_bus_finish ()

    PhoshNotifyDBusNotifications *
    phosh_notify_dbus_notifications_proxy_new_for_bus_finish
                                   (GAsyncResult *res,
                                    GError **error);

Finishes an operation started with `phosh_notify_dbus_notifications_proxy_new_for_bus()`.

#### Parameters

res | The GAsyncResult obtained from the GAsyncReadyCallback passed to `phosh_notify_dbus_notifications_proxy_new_for_bus()`. |
error | Return location for error or `NULL` |

#### Returns

The constructed proxy object or `NULL` if `error` is set.

[transfer full][type PhoshNotifyDBusNotificationsProxy]

### phosh_notify_dbus_notifications_proxy_new_for_bus_sync ()

    PhoshNotifyDBusNotifications *
    phosh_notify_dbus_notifications_proxy_new_for_bus_sync
                                   (GBusType bus_type,
                                    GDBusProxyFlags flags,
                                    const gchar *name,
                                    const gchar *object_path,
                                    GCancellable *cancellable,
                                    GError **error);

Like `phosh_notify_dbus_notifications_proxy_new_sync()` but takes a GBusType instead of a GDBusConnection.

The calling thread is blocked until a reply is received.

See `phosh_notify_dbus_notifications_proxy_new_for_bus()` for the asynchronous version of this constructor.

#### Parameters

bus_type | A GBusType. |
flags | Flags from the GDBusProxyFlags enumeration. |
name | A bus name (well-known or unique). |
object_path | An object path. |
cancellable | A GCancellable or `NULL`. | [nullable]
error | Return location for error or `NULL` |

#### Returns

The constructed proxy object or `NULL` if `error` is set.

[transfer full][type PhoshNotifyDBusNotificationsProxy]

### phosh_notify_dbus_notifications_skeleton_new ()

    PhoshNotifyDBusNotifications *
    phosh_notify_dbus_notifications_skeleton_new
                                   (void);

Creates a skeleton object for the D-Bus interface org.freedesktop.Notifications.

#### Returns

The skeleton object.

[transfer full][type PhoshNotifyDBusNotificationsSkeleton]

## Types and Values

### struct PhoshNotifyDBusNotificationsIface

    struct PhoshNotifyDBusNotificationsIface {
      GTypeInterface parent_iface;

      gboolean (*handle_close_notification) (
        PhoshNotifyDBusNotifications *object,
        GDBusMethodInvocation *invocation,
        guint arg_id);

      gboolean (*handle_get_capabilities) (
        PhoshNotifyDBusNotifications *object,
        GDBusMethodInvocation *invocation);

      gboolean (*handle_get_server_information) (
        PhoshNotifyDBusNotifications *object,
        GDBusMethodInvocation *invocation);

      gboolean (*handle_notify) (
        PhoshNotifyDBusNotifications *object,
        GDBusMethodInvocation *invocation,
        const gchar *arg_app_name,
        guint arg_replaces_id,
        const gchar *arg_app_icon,
        const gchar *arg_summary,
        const gchar *arg_body,
        const gchar *const *arg_actions,
        GVariant *arg_hints,
        gint arg_expire_timeout);

      void (*action_invoked) (
        PhoshNotifyDBusNotifications *object,
        guint arg_id,
        const gchar *arg_action_key);

      void (*notification_closed) (
        PhoshNotifyDBusNotifications *object,
        guint arg_id,
        guint arg_reason);
    };

Virtual table for the D-Bus interface org.freedesktop.Notifications.

#### Members

GTypeInterface `parent_iface`; | The parent interface. |
`handle_close_notification` () | Handler for the “handle-close-notification” signal. |
`handle_get_capabilities` () | Handler for the “handle-get-capabilities” signal. |
`handle_get_server_information` () | Handler for the “handle-get-server-information” signal. |
`handle_notify` () | Handler for the “handle-notify” signal. |
`action_invoked` () | Handler for the “action-invoked” signal. |
`notification_closed` () | Handler for the “notification-closed” signal. |

### struct PhoshNotifyDBusNotificationsProxy

    struct PhoshNotifyDBusNotificationsProxy;

The PhoshNotifyDBusNotificationsProxy structure contains only private data and should only be accessed using the provided API.

### struct PhoshNotifyDBusNotificationsProxyClass

    struct PhoshNotifyDBusNotificationsProxyClass {
      GDBusProxyClass parent_class;
    };

Class structure for PhoshNotifyDBusNotificationsProxy.

#### Members

### struct PhoshNotifyDBusNotificationsSkeleton

    struct PhoshNotifyDBusNotificationsSkeleton;

The PhoshNotifyDBusNotificationsSkeleton structure contains only private data and should only be accessed using the provided API.

### struct PhoshNotifyDBusNotificationsSkeletonClass

    struct PhoshNotifyDBusNotificationsSkeletonClass {
      GDBusInterfaceSkeletonClass parent_class;
    };

Class structure for PhoshNotifyDBusNotificationsSkeleton.

#### Members

### PhoshNotifyDBusNotifications

    typedef struct _PhoshNotifyDBusNotifications PhoshNotifyDBusNotifications;

Abstract interface type for the D-Bus interface org.freedesktop.Notifications.

### PhoshNotifyDBusNotificationsProxyPrivate

    typedef struct _PhoshNotifyDBusNotificationsProxyPrivate PhoshNotifyDBusNotificationsProxyPrivate;

### PhoshNotifyDBusNotificationsSkeletonPrivate

    typedef struct _PhoshNotifyDBusNotificationsSkeletonPrivate PhoshNotifyDBusNotificationsSkeletonPrivate;

## Signal Details

### The `“action-invoked”` signal

    void
    user_function (PhoshNotifyDBusNotifications *object,
                   guint                         arg_id,
                   char                         *arg_action_key,
                   gpointer                      user_data)

On the client-side, this signal is emitted whenever the D-Bus signal "ActionInvoked" is received.

On the service-side, this signal can be used with e.g. `g_signal_emit_by_name()` to make the object emit the D-Bus signal.

#### Parameters

object | A PhoshNotifyDBusNotifications. |
arg_id | Argument. |
arg_action_key | Argument. |
user_data | user data set when the signal handler was connected. |

Flags: Run Last

### The `“handle-close-notification”` signal

    gboolean
    user_function (PhoshNotifyDBusNotifications *object,
                   GDBusMethodInvocation        *invocation,
                   guint                         arg_id,
                   gpointer                      user_data)

Signal emitted when a remote caller is invoking the `CloseNotification()` D-Bus method.

If a signal handler returns `TRUE`, it means the signal handler will handle the invocation (e.g. take a reference to `invocation` and eventually call `phosh_notify_dbus_notifications_complete_close_notification()` or e.g. `g_dbus_method_invocation_return_error()` on it) and no other signal handlers will run. If no signal handler handles the invocation, the `G_DBUS_ERROR_UNKNOWN_METHOD` error is returned.

#### Parameters

object | A PhoshNotifyDBusNotifications. |
invocation | A GDBusMethodInvocation. |
arg_id | Argument passed by remote caller. |
user_data | user data set when the signal handler was connected. |

#### Returns

`G_DBUS_METHOD_INVOCATION_HANDLED` or `TRUE` if the invocation was handled, `G_DBUS_METHOD_INVOCATION_UNHANDLED` or `FALSE` to let other signal handlers run.

Flags: Run Last

### The `“handle-get-capabilities”` signal

    gboolean
    user_function (PhoshNotifyDBusNotifications *object,
                   GDBusMethodInvocation        *invocation,
                   gpointer                      user_data)

Signal emitted when a remote caller is invoking the `GetCapabilities()` D-Bus method.

If a signal handler returns `TRUE`, it means the signal handler will handle the invocation (e.g. take a reference to `invocation` and eventually call `phosh_notify_dbus_notifications_complete_get_capabilities()` or e.g. `g_dbus_method_invocation_return_error()` on it) and no other signal handlers will run. If no signal handler handles the invocation, the `G_DBUS_ERROR_UNKNOWN_METHOD` error is returned.

#### Parameters

object | A PhoshNotifyDBusNotifications. |
invocation | A GDBusMethodInvocation. |
user_data | user data set when the signal handler was connected. |

#### Returns

`G_DBUS_METHOD_INVOCATION_HANDLED` or `TRUE` if the invocation was handled, `G_DBUS_METHOD_INVOCATION_UNHANDLED` or `FALSE` to let other signal handlers run.

Flags: Run Last

### The `“handle-get-server-information”` signal

    gboolean
    user_function (PhoshNotifyDBusNotifications *object,
                   GDBusMethodInvocation        *invocation,
                   gpointer                      user_data)

Signal emitted when a remote caller is invoking the `GetServerInformation()` D-Bus method.

If a signal handler returns `TRUE`, it means the signal handler will handle the invocation (e.g. take a reference to `invocation` and eventually call `phosh_notify_dbus_notifications_complete_get_server_information()` or e.g. `g_dbus_method_invocation_return_error()` on it) and no other signal handlers will run. If no signal handler handles the invocation, the `G_DBUS_ERROR_UNKNOWN_METHOD` error is returned.

#### Parameters

object | A PhoshNotifyDBusNotifications. |
invocation | A GDBusMethodInvocation. |
user_data | user data set when the signal handler was connected. |

#### Returns

`G_DBUS_METHOD_INVOCATION_HANDLED` or `TRUE` if the invocation was handled, `G_DBUS_METHOD_INVOCATION_UNHANDLED` or `FALSE` to let other signal handlers run.

Flags: Run Last

### The `“handle-notify”` signal

    gboolean
    user_function (PhoshNotifyDBusNotifications *object,
                   GDBusMethodInvocation        *invocation,
                   char                         *arg_app_name,
                   guint                         arg_replaces_id,
                   char                         *arg_app_icon,
                   char                         *arg_summary,
                   char                         *arg_body,
                   GStrv                         arg_actions,
                   GVariant                     *arg_hints,
                   int                           arg_expire_timeout,
                   gpointer                      user_data)

Signal emitted when a remote caller is invoking the `Notify()` D-Bus method.

If a signal handler returns `TRUE`, it means the signal handler will handle the invocation (e.g. take a reference to `invocation` and eventually call `phosh_notify_dbus_notifications_complete_notify()` or e.g. `g_dbus_method_invocation_return_error()` on it) and no other signal handlers will run. If no signal handler handles the invocation, the `G_DBUS_ERROR_UNKNOWN_METHOD` error is returned.

#### Parameters

object | A PhoshNotifyDBusNotifications. |
invocation | A GDBusMethodInvocation. |
arg_app_name | Argument passed by remote caller. |
arg_replaces_id | Argument passed by remote caller. |
arg_app_icon | Argument passed by remote caller. |
arg_summary | Argument passed by remote caller. |
arg_body | Argument passed by remote caller. |
arg_actions | Argument passed by remote caller. |
arg_hints | Argument passed by remote caller. |
arg_expire_timeout | Argument passed by remote caller. |
user_data | user data set when the signal handler was connected. |

#### Returns

`G_DBUS_METHOD_INVOCATION_HANDLED` or `TRUE` if the invocation was handled, `G_DBUS_METHOD_INVOCATION_UNHANDLED` or `FALSE` to let other signal handlers run.

Flags: Run Last

### The `“notification-closed”` signal

    void
    user_function (PhoshNotifyDBusNotifications *object,
                   guint                         arg_id,
                   guint                         arg_reason,
                   gpointer                      user_data)

On the client-side, this signal is emitted whenever the D-Bus signal "NotificationClosed" is received.

On the service-side, this signal can be used with e.g. `g_signal_emit_by_name()` to make the object emit the D-Bus signal.

#### Parameters

object | A PhoshNotifyDBusNotifications. |
arg_id | Argument. |
arg_reason | Argument. |
user_data | user data set when the signal handler was connected. |

Flags: Run Last